close all
clear all
clc
MOGCO_50 = load('MOCLPSO_KUR_50.txt');
MOGCO_100 = load('MOCLPSO_KUR_100.txt');
MOGCO_150 = load('MOCLPSO_KUR_150.txt');
MOGCO_200 = load('MOCLPSO_KUR_200.txt');
MOGCO_250 = load('MOCLPSO_KUR_250.txt');
%true_optimal_front = load('KUR_optimal_front.txt');

rep11 = sortrows(MOGCO_50,9);
f1 = rep11(:,9);
f2 = rep11(:,10);
plot(f1,f2,'MarkerFaceColor',[1 1 1],...
    'MarkerEdgeColor',[1 0 0],...
    'MarkerSize',12,...
    'Marker','x',...
    'LineWidth',1.5,...
    'Color',[1 0 0],...
    'DisplayName','Function Evaluation = 5000');
hold on
rep11 = sortrows(MOGCO_100,9);
f1 = rep11(:,9);
f2 = rep11(:,10);
plot(f1,f2,'MarkerFaceColor',[1 1 1],...
    'MarkerEdgeColor',[0 1 0],...
    'MarkerSize',12,...
    'Marker','x',...
    'LineWidth',1.5,...
    'Color',[0 1 0],...
    'DisplayName','Function Evaluation = 10000');
hold on

rep11 = sortrows(MOGCO_150,9);
f1 = rep11(:,9);
f2 = rep11(:,10);
plot(f1,f2,'MarkerFaceColor',[1 1 1],...
    'MarkerEdgeColor',[0 0 1],...
    'MarkerSize',12,...
    'Marker','x',...
    'LineWidth',1.5,...
    'Color',[0 0 1],...
    'DisplayName','Function Evaluation = 15000');
hold on

rep11 = sortrows(MOGCO_200,9);
f1 = rep11(:,9);
f2 = rep11(:,10);
plot(f1,f2,'MarkerFaceColor',[1 1 1],...
    'MarkerEdgeColor',[0 1 1],...
    'MarkerSize',12,...
    'Marker','x',...
    'LineWidth',1.5,...
    'Color',[0 1 1],...
    'DisplayName','Function Evaluation = 20000');
hold on

rep11 = sortrows(MOGCO_250,9);
f1 = rep11(:,9);
f2 = rep11(:,10);
plot(f1,f2,'-mx','LineWidth',1.5,...
     'MarkerEdgeColor','m',...
     'MarkerSize',12,...
    'Marker','x',...
    'LineWidth',1.5,...
    'Color',[1 0 1],...
    'DisplayName','Function Evaluation = 25000');
hold on

rep11 = load('KUR_optimal_front.txt');
rep11 = sortrows(rep11,1);
f1 = rep11(:,1);
f2 = rep11(:,2);
plot(f1,f2,'-k','LineWidth',1.5,...
                'MarkerEdgeColor','k',...
                'MarkerFaceColor',[1 1 1],...
                'MarkerSize',8)
            
h = legend('FE = 5000', 'FE = 10000','FE = 15000','FE = 20000','FE = 25000','KUR_optimal',0);
set(h,'Interpreter','none')   
% Create xlabel
xlabel('Objective Function 1','FontWeight','bold','FontSize',24,...
    'FontName','Arial Black');

% Create ylabel
ylabel('Objective Function 2','FontWeight','bold','FontSize',24,...
    'FontName','Arial Black');

% Create title
title('MOGCO','FontWeight','bold','FontSize',24,...
    'FontName','Arial Black');