close all
clear all
clc
MOGCO_50 = load('MOPCLSO_ZDT6_50.txt');
MOGCO_100 = load('MOPCLSO_ZDT6_100.txt');
MOGCO_150 = load('MOPCLSO_ZDT6_150.txt');
MOGCO_200 = load('MOPCLSO_ZDT6_200.txt');
MOGCO_250 = load('MOPCLSO_ZDT6_250.txt');
true_optimal_front = load('ZDT6_optimal_front.txt');

MOGCO_50 = MOGCO_50';
MOGCO_50 = sortrows(MOGCO_50,1);
f1 = MOGCO_50(:,1);
f2 = MOGCO_50(:,2);
plot(f1,f2,'MarkerFaceColor',[1 1 1],...
    'MarkerEdgeColor',[1 0 0],...
    'MarkerSize',12,...
    'Marker','x',...
    'LineWidth',1.5,...
    'Color',[1 0 0],...
    'DisplayName','Function Evaluation = 5000');

hold on
MOGCO_50 = MOGCO_100';
MOGCO_50 = sortrows(MOGCO_50,1);
f1 = MOGCO_50(:,1);
f2 = MOGCO_50(:,2);
plot(f1, f2,'MarkerFaceColor',[1 1 1],...
    'MarkerEdgeColor',[0 1 0],...
    'MarkerSize',12,...
    'Marker','p',...
    'LineWidth',1.5,...
    'Color',[0 1 0],...
    'DisplayName','Function Evaluation = 10000');
hold on

MOGCO_50 = MOGCO_150';
MOGCO_50 = sortrows(MOGCO_50,1);
f1 = MOGCO_50(:,1);
f2 = MOGCO_50(:,2);
plot(f1, f2,'MarkerFaceColor',[1 1 1],...
    'MarkerEdgeColor',[0 0 1],...
    'MarkerSize',12,...
    'Marker','s',...
    'LineWidth',1.5,...
    'Color',[0 0 1],...
    'DisplayName','Function Evaluation = 15000');
hold on

MOGCO_50 = MOGCO_200';
MOGCO_50 = sortrows(MOGCO_50,1);
f1 = MOGCO_50(:,1);
f2 = MOGCO_50(:,2);
plot(f1, f2,'MarkerFaceColor',[1 1 1],...
    'MarkerEdgeColor',[0 1 1],...
    'MarkerSize',12,...
    'Marker','o',...
    'LineWidth',1.5,...
    'Color',[0 1 1],...
    'DisplayName','Function Evaluation = 20000');
hold on

MOGCO_50 = MOGCO_250';
MOGCO_50 = sortrows(MOGCO_50,1);
f1 = MOGCO_50(:,1);
f2 = MOGCO_50(:,2);
plot(f1, f2,'-mx','LineWidth',1.5,...
     'MarkerEdgeColor','m',...
     'MarkerSize',12,...
    'Marker','x',...
    'LineWidth',1.5,...
    'Color',[1 1 1],...
    'DisplayName','Function Evaluation = 25000');
hold on

rep11 = load('ZDT6_optimal_front.txt');
% rep11 = sortrows(rep11,1);
f1 = rep11(:,1);
f2 = rep11(:,2);
plot(f1,f2,'-k','LineWidth',1.5,...
                'MarkerEdgeColor','k',...
                'MarkerFaceColor',[1 1 1],...
                'MarkerSize',8)
            
h = legend('FE = 5000', 'FE = 10000','FE = 15000','FE = 20000','FE = 25000','ZDT6_optimal',0);
set(h,'Interpreter','none')   
% Create xlabel
xlabel('Objective Function 1','FontWeight','bold','FontSize',24,...
    'FontName','Arial Black');

% Create ylabel
ylabel('Objective Function 2','FontWeight','bold','FontSize',24,...
    'FontName','Arial Black');

% Create title
title('MOCLPSO','FontWeight','bold','FontSize',24,...
    'FontName','Arial Black');