function mogco(pop,gen)
% for q = 1:5
%% Simple error checking
% Number of Arguments
% Check for the number of arguments. The two input arguments are necessary
% to run this function.
if nargin < 2
    error('MOPSO: Please enter the population size and number of generations as input arguments.');
end
% Both the input arguments need to of integer data type
if isnumeric(pop) == 0 || isnumeric(gen) == 0
    error('Both input arguments pop and gen should be integer datatype');
end
% Minimum population size has to be 20 individuals
if pop < 5
    error('Minimum population for running this function is 20');
end
if gen < 5
    error('Minimum number of generations is 5');
end
% Make sure pop and gen are integers
pop = round(pop);
gen = round(gen);
iteration = 50;
tr = 2.0;
mdf_max = 0.5;
r2 = 0;
%% Function range setting
% for i = 1:30
%     ZDT11(i,1)= 0;
%     ZDT11(i,2)= 1;
% end
% save ZDT1.txt ZDT11 -ASCII 
final_result = [];
for n = 1:iteration
%% Objective Function descreption
input_file = load ('ZDT2.txt');
true_optimal_front = load('ZDT2_optimal_front.txt');
[dim, c]= size(input_file);
objectives = 2;
m = dim + objectives;
pbest = m + dim;
best_fit = pbest + objectives;
clear c
for l = 1:dim
    min_range(l) = input_file(l,1);
    max_range(l) = input_file(l,2);
end
%% Initialize the variables
chromosome = initialize_variables(pop, objectives, dim,min_range,max_range);
%% Sort the initialized population
% Sort the population using non-domination-sort. This returns two columns
% for each individual which are the rank and the crowding distance
% corresponding to their position in the front they belong. At this stage
% the rank and the crowding distance for each chromosome is added to the
% chromosome vector for easy of computation.
chromosome = non_domination_sort_mod(chromosome, objectives, dim);
%% Sort the initialized population
% chromosome = non_domination_sort_mod(chromosome, M, V);
%% Start the evolution process
for i = 1 : gen
%     w = w0*(((w0-w1)*i)/gen);
    for j = 1:pop
        for k = 1:dim            
            decission_value = rand(1);
            if decission_value < 0.9                      % Don't change own decision
                argu = rand(1);
                if argu < 0.1                   
                    no_of_helpers = 2;
                    
                    
%                     no_of_helpers = ceil(3*rand(1));
                    help1 = 0;
                    
                    
                    help2 = 0;

                    
                    for x = 1:no_of_helpers                       
                        istefada1 = ceil(pop*rand(1));
                        
                        istefada2 = ceil(pop*rand(1)); %new code
                        
                        while istefada1 == j
                            istefada1 = ceil(pop*rand(1));
                        end    
                        
                        
                        while istefada2 == j  %new code
                            istefada2 = ceil(pop*rand(1));
                        end  
                       
                      
                        help1 = help1 +(chromosome(istefada1,m+k)- chromosome(j,k));
                        
                        help2 = help2 +(chromosome(istefada2,m+k)- chromosome(j,k)); %new code

%                         help = help + chromosome(istefada,obj+k);
                    end
                    
                    % avg_help = help/no_of_helpers;
                    if(help1 < help2)
                            avg_help = help1/no_of_helpers;
                    end
                    if(help2 < help1)
                            avg_help = help2/no_of_helpers;
                    end
%                     new_value = (min_range(k) + (max_range(k) - min_range(k))*rand(1));
                    chromosome(j,k)=(chromosome(j,k)+ avg_help);
                    
                    
                    
%                     new_value = (min_range(k) + (max_range(k) - min_range(k))*rand(1));
                    chromosome(j,k)=(chromosome(j,k)+ avg_help);
                    if chromosome(j,k)< min_range(k)
                        chromosome(j,k)=  min_range(k);
                    end
                    if chromosome(j,k)> max_range(k)
                        chromosome(j,k)=  max_range(k);
                    end  
                else                    
                    chromosome(j,k)=(chromosome(j,k)+(chromosome(j,m+k)- chromosome(j,k)));
                    if chromosome(j,k)< min_range(k)
                        chromosome(j,k)=  min_range(k);
                    end
                    if chromosome(j,k)> max_range(k)
                        chromosome(j,k)=  max_range(k);
                    end 
                end
            else
                    mdf = mdf_max*(1-(i/gen)^tr);
%                     new_value = (min_range(k) + (max_range(k) - min_range(k))*rand(1));                  
                    chromosome(j,k)= (chromosome(j,k)+ (-mdf + 2*mdf*rand(1)));
%                     chromosome(j,k)= (chromosome(j,k)+ 0.99*(new_value - chromosome(j,k)));
                    if chromosome(j,k)< min_range(k)
                        chromosome(j,k)=  min_range(k);
                    end
                    if chromosome(j,k)> max_range(k)
                        chromosome(j,k)=  max_range(k);
                    end
%                 end 
             end
         end
    end
% Calculate the objectives of the network
    for j = 1:pop
        chromosome(j,dim+1:m) = ZDT2(chromosome(j,1:dim),objectives, dim);
    end
    for j = 1:pop     
        dom_less = 0;
        dom_equal= 0;
        dom_more = 0;
         for k = 1 : objectives
            if (chromosome(j,dim + k) < chromosome(j,pbest+k))
                dom_less = dom_less + 1;
             elseif (chromosome(j,dim + k) == chromosome(j,pbest+k))
                dom_equal = dom_equal + 1;
             else
                dom_more = dom_more + 1;
            end
         end 
         if  dom_more ==0 && dom_equal ~= objectives 
             chromosome(j,m+1:pbest)= chromosome(j,1:dim);
             chromosome(j,pbest+1:best_fit)= chromosome(j,dim+1:m);
         end
    end 
            if ~mod(i,10)
                clc
                fprintf('%d Iteration in progress\n',n);
                fprintf('%d generations completed\n',i);
            end
end
    raw_rep = [];
    rep1 = [];
    raw_rep= non_domination_sort_mod(chromosome, objectives, dim);
    rep1 = raw_rep(1,:);
       [raw_r c] = size(raw_rep);
       clear c
         for k = 2:raw_r 
              if raw_rep(k,best_fit+1) == 1
                 rep1 = cat(1,rep1, raw_rep(k,:));
               end
         end
    generational_distance_metic(n,1) = generational_distance(rep1,true_optimal_front,objectives);
    diversity(n,1) = deversity_metric(rep1,true_optimal_front,objectives);
    error_metric(n,1) = error_ratio(rep1,true_optimal_front,objectives);
    [rr1 cc1] = size(rep1);
    [rrr1 ccc1] = size(final_result);
    advances = rr1+rrr1;
    final_result(rrr1+1:advances,:)= rep1;
end
        gen_distance(1,1) = min(generational_distance_metic);
        gen_distance(2,1) = max(generational_distance_metic);
        gen_distance(3,1) = mean(generational_distance_metic);
        gen_distance(4,1) = median(generational_distance_metic);
        gen_distance(5,1) = std(generational_distance_metic);
        
        diversity_distance(1,1) = min(diversity);
        diversity_distance(2,1) = max(diversity);
        diversity_distance(3,1) = mean(diversity);
        diversity_distance(4,1) = median(diversity);
        diversity_distance(5,1) = std(diversity);
        
        ER(1,1) = min(error_metric);
        ER(2,1) = max(error_metric);
        ER(3,1) = mean(error_metric);
        ER(4,1) = median(error_metric);
        ER(5,1) = std(error_metric);
        
        optimal_front(final_result,objectives)

%% Result
% Save the result in ASCII text format.
save gen_distance.txt gen_distance -ASCII
save diversity_distance.txt diversity_distance -ASCII
save ER.txt ER -ASCII
% save ZDT2_solution.txt final_result -ASCII
end
