close all
clear all
clc
MOGCO_50 = load('MOGCO_ZDT1_50.txt');
MOGCO_100 = load('MOGCO_ZDT1_100.txt');
MOGCO_150 = load('MOGCO_ZDT1_150.txt');
MOGCO_200 = load('MOGCO_ZDT1_200.txt');
MOGCO_250 = load('MOGCO_ZDT1_250.txt');
true_optimal_front = load('ZDT1_optimal_front.txt');

rep11 = sortrows(MOGCO_50,63);
f1 = rep11(:,63);
f2 = rep11(:,64);
plot(f1, f2,'MarkerFaceColor',[1 1 1],...
    'MarkerEdgeColor',[1 0 0],...
    'MarkerSize',12,...
    'Marker','x',...
    'LineWidth',1.5,...
    'Color',[1 0 0],...
    'DisplayName','Function Evaluation = 5000');
hold on
rep11 = sortrows(MOGCO_100,63);
f1 = rep11(:,63);
f2 = rep11(:,64);
plot(f1, f2,'MarkerFaceColor',[1 1 1],...
    'MarkerEdgeColor',[0 1 0],...
    'MarkerSize',12,...
    'Marker','x',...
    'LineWidth',1.5,...
    'Color',[0 1 0],...
    'DisplayName','Function Evaluation = 10000');
hold on

rep11 = sortrows(MOGCO_150,63);
f1 = rep11(:,63);
f2 = rep11(:,64);
plot(f1, f2,'MarkerFaceColor',[1 1 1],...
    'MarkerEdgeColor',[0 0 1],...
    'MarkerSize',12,...
    'Marker','x',...
    'LineWidth',1.5,...
    'Color',[0 0 1],...
    'DisplayName','Function Evaluation = 15000');
hold on

rep11 = sortrows(MOGCO_200,63);
f1 = rep11(:,63);
f2 = rep11(:,64);
plot(f1, f2,'MarkerFaceColor',[1 1 1],...
    'MarkerEdgeColor',[0 1 1],...
    'MarkerSize',12,...
    'Marker','x',...
    'LineWidth',1.5,...
    'Color',[0 1 1],...
    'DisplayName','Function Evaluation = 20000');
hold on

rep11 = sortrows(MOGCO_250,63);
f1 = rep11(:,63);
f2 = rep11(:,64);
plot(f1, f2,'-mx','LineWidth',1.5,...
     'MarkerEdgeColor','m',...
     'MarkerSize',12,...
    'Marker','x',...
    'LineWidth',1.5,...
    'Color',[1 1 1],...
    'DisplayName','Function Evaluation = 25000');
hold on

rep11 = load('ZDT1_optimal_front.txt');
rep11 = sortrows(rep11,1);
plot(f1,f2,'-kx','LineWidth',1.5,...
                'MarkerEdgeColor','k',...
                'MarkerFaceColor',[1 1 1],...
                'MarkerSize',8)
            
h = legend('FE = 5000', 'FE = 10000','FE = 15000','FE = 20000','FE = 25000','ZDT1_optimal',0);
set(h,'Interpreter','none')   
% Create xlabel
xlabel('Objective Function 1','FontWeight','bold','FontSize',24,...
    'FontName','Arial Black');

% Create ylabel
ylabel('Objective Function 2','FontWeight','bold','FontSize',24,...
    'FontName','Arial Black');

% Create title
title('MOGCO','FontWeight','bold','FontSize',24,...
    'FontName','Arial Black');