function chromosome = initialize_variables(pop, objectives, dim, min_range, max_range)
m = dim + objectives;
pbest = m + dim;
best_fit = pbest+objectives;
%% Initialize each swarm
for i = 1 : pop
    % Initialize the decision variables based on the minimum and maximum
    % possible values. dim is the number of decision variable. A random
    % number is picked between the minimum and maximum possible values for
    % the each decision variable.
    for j = 1 : dim
        chromosome(i,j) = min_range(j) + (max_range(j) - min_range(j))*rand(1);
    end
%% Objective functions
    chromosome(i,dim+1:m) = ZDT2(chromosome(i,1:dim),objectives, dim);
%% Personal Best Positions and Objective functions
    chromosome(i,m+1:pbest)= chromosome(i,1:dim);
    chromosome(i,pbest+1:best_fit)=chromosome(i,dim+1:m);
end