close all
clear all
clc
MOGCO_50 = load('NSGA-II_ZDT3_50.txt');
MOGCO_100 = load('NSGA-II_ZDT3_100.txt');
MOGCO_150 = load('NSGA-II_ZDT3_150.txt');
MOGCO_200 = load('NSGA-II_ZDT3_200.txt');
MOGCO_250 = load('NSGA-II_ZDT3_250.txt');
true_optimal_front = load('ZDT3_optimal_front.txt');

rep11 = sortrows(MOGCO_50,31);
f1 = rep11(:,31);
f2 = rep11(:,32);
plot(f1, f2,'MarkerFaceColor',[1 1 1],...
    'MarkerEdgeColor',[1 0 0],...
    'MarkerSize',12,...
    'Marker','x',...
    'LineWidth',1.5,...
    'Color',[1 0 0],...
    'DisplayName','Function Evaluation = 5000');
hold on
rep11 = sortrows(MOGCO_100,31);
f1 = rep11(:,31);
f2 = rep11(:,32);
plot(f1, f2,'MarkerFaceColor',[1 1 1],...
    'MarkerEdgeColor',[0 1 0],...
    'MarkerSize',12,...
    'Marker','p',...
    'LineWidth',1.5,...
    'Color',[0 1 0],...
    'DisplayName','Function Evaluation = 10000');
hold on

rep11 = sortrows(MOGCO_150,31);
f1 = rep11(:,31);
f2 = rep11(:,32);
plot(f1, f2,'MarkerFaceColor',[1 1 1],...
    'MarkerEdgeColor',[0 0 1],...
    'MarkerSize',12,...
    'Marker','s',...
    'LineWidth',1.5,...
    'Color',[0 0 1],...
    'DisplayName','Function Evaluation = 15000');
hold on

rep11 = sortrows(MOGCO_200,31);
f1 = rep11(:,31);
f2 = rep11(:,32);
plot(f1, f2,'MarkerFaceColor',[1 1 1],...
    'MarkerEdgeColor',[0 1 1],...
    'MarkerSize',12,...
    'Marker','o',...
    'LineWidth',1.5,...
    'Color',[0 1 1],...
    'DisplayName','Function Evaluation = 20000');
hold on

rep11 = sortrows(MOGCO_250,31);
f1 = rep11(:,31);
f2 = rep11(:,32);
plot(f1, f2,'-mx','LineWidth',1.5,...
     'MarkerEdgeColor','m',...
     'MarkerSize',12,...
    'Marker','*',...
    'LineWidth',1.5,...
    'Color',[1 1 1],...
    'DisplayName','Function Evaluation = 25000');
hold on

rep11 = load('ZDT3_optimal_front.txt');
rep11 = sortrows(rep11,1);
plot(f1,f2,'-k','LineWidth',1.5,...
                'MarkerEdgeColor','k',...
                'MarkerFaceColor',[1 1 1],...
                'MarkerSize',8)
            
h = legend('FE = 5000', 'FE = 10000','FE = 15000','FE = 20000','FE = 25000','ZDT3_optimal',0);
set(h,'Interpreter','none')   
% Create xlabel
xlabel('Objective Function 1','FontWeight','bold','FontSize',24,...
    'FontName','Arial Black');

% Create ylabel
ylabel('Objective Function 2','FontWeight','bold','FontSize',24,...
    'FontName','Arial Black');

% Create title
title('NSGA-II','FontWeight','bold','FontSize',24,...
    'FontName','Arial Black');