close all
clear all
clc
MOGCO_50 = load('NSGA-II_ZDT4_250.txt');
MOGCO_100 = load('NSGA-II_ZDT4_300.txt');
MOGCO_150 = load('NSGA-II_ZDT4_350.txt');
MOGCO_200 = load('NSGA-II_ZDT4_400.txt');
MOGCO_250 = load('NSGA-II_ZDT4_450.txt');
true_optimal_front = load('ZDT4_optimal_front.txt');

rep11 = sortrows(MOGCO_50,11);
f1 = rep11(:,11);
f2 = rep11(:,12);
plot(f1, f2,'MarkerFaceColor',[1 1 1],...
    'MarkerEdgeColor',[1 0 0],...
    'MarkerSize',12,...
    'Marker','x',...
    'LineWidth',1.5,...
    'Color',[1 0 0],...
    'DisplayName','Function Evaluation = 5000');
hold on
rep11 = sortrows(MOGCO_100,11);
f1 = rep11(:,11);
f2 = rep11(:,12);
plot(f1, f2,'MarkerFaceColor',[1 1 1],...
    'MarkerEdgeColor',[0 1 0],...
    'MarkerSize',12,...
    'Marker','p',...
    'LineWidth',1.5,...
    'Color',[0 1 0],...
    'DisplayName','Function Evaluation = 10000');
hold on

rep11 = sortrows(MOGCO_150,11);
f1 = rep11(:,11);
f2 = rep11(:,12);
plot(f1, f2,'MarkerFaceColor',[1 1 1],...
    'MarkerEdgeColor',[0 0 1],...
    'MarkerSize',12,...
    'Marker','s',...
    'LineWidth',1.5,...
    'Color',[0 0 1],...
    'DisplayName','Function Evaluation = 15000');
hold on

rep11 = sortrows(MOGCO_200,11);
f1 = rep11(:,11);
f2 = rep11(:,12);
plot(f1, f2,'MarkerFaceColor',[1 1 1],...
    'MarkerEdgeColor',[0 1 1],...
    'MarkerSize',12,...
    'Marker','o',...
    'LineWidth',1.5,...
    'Color',[0 1 1],...
    'DisplayName','Function Evaluation = 20000');
hold on

rep11 = sortrows(MOGCO_250,11);
f1 = rep11(:,11);
f2 = rep11(:,12);
plot(f1, f2,'-mx','LineWidth',1.5,...
     'MarkerEdgeColor','m',...
     'MarkerSize',12,...
    'Marker','*',...
    'LineWidth',1.5,...
    'Color',[1 1 1],...
    'DisplayName','Function Evaluation = 25000');
hold on

rep11 = load('ZDT4_optimal_front.txt');
rep11 = sortrows(rep11,1);
plot(f1,f2,'-k','LineWidth',1.5,...
                'MarkerEdgeColor','k',...
                'MarkerFaceColor',[1 1 1],...
                'MarkerSize',8)
            
h = legend('FE = 25000', 'FE = 30000','FE = 35000','FE = 40000','FE = 45000','ZDT4_optimal',0);
set(h,'Interpreter','none')   
% Create xlabel
xlabel('Objective Function 1','FontWeight','bold','FontSize',24,...
    'FontName','Arial Black');

% Create ylabel
ylabel('Objective Function 2','FontWeight','bold','FontSize',24,...
    'FontName','Arial Black');

% Create title
title('NSGA-II','FontWeight','bold','FontSize',24,...
    'FontName','Arial Black');